import { NormalizedKeyMetadata as $64$luvio_engine_NormalizedKeyMetadata } from '@luvio/engine';
export declare const ObjectKeys: {
    (o: object): string[];
    (o: {}): string[];
}, ObjectCreate: {
    (o: object | null): any;
    (o: object | null, properties: PropertyDescriptorMap & ThisType<any>): any;
}, ObjectAssign: {
    <T extends {}, U>(target: T, source: U): T & U;
    <T_1 extends {}, U_1, V>(target: T_1, source1: U_1, source2: V): T_1 & U_1 & V;
    <T_2 extends {}, U_2, V_1, W>(target: T_2, source1: U_2, source2: V_1, source3: W): T_2 & U_2 & V_1 & W;
    (target: object, ...sources: any[]): any;
};
export declare const ArrayIsArray: (arg: any) => arg is any[];
export declare const JSONStringify: {
    (value: any, replacer?: ((this: any, key: string, value: any) => any) | undefined, space?: string | number | undefined): string;
    (value: any, replacer?: (string | number)[] | null | undefined, space?: string | number | undefined): string;
};
type AllowedPrimitives = boolean | string | number | Date | null;
type Value<T> = T extends AllowedPrimitives ? T : RecursivePartial<T>;
export type RecursivePartial<T> = null | {
    [P in keyof T]?: T[P] extends Array<infer U> ? Array<Value<U>> | null : Value<T[P]> | null;
};
export declare function equalsArray<U, V extends U[]>(a: V, b: V, equalsItem: (itemA: U, itemB: U) => boolean | void): boolean;
export declare function equalsObject<U, V extends {
    [key: string]: U;
}>(a: V, b: V, equalsProp: (propA: U, propB: U) => boolean | void): boolean;
export declare function createLink(ref: string | $64$luvio_engine_NormalizedKeyMetadata): {
    __ref: string;
};
export declare function assignMetadataLink(entry: any, metadataKey: string | $64$luvio_engine_NormalizedKeyMetadata): void;
export {};
